/*
	This file contains the entry point (Reset_Handler) of your firmware project.
	The reset handled initializes the RAM and calls system library initializers as well as
	the platform-specific initializer and the main() function.
*/

extern void *_estack;

#define NULL ((void *)0)

void Reset_Handler();
void Default_Handler();

#ifdef DEBUG_DEFAULT_INTERRUPT_HANDLERS
void __attribute__ ((weak)) NMI_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void NMI_Handler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) HardFault_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void HardFault_Handler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SVC_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SVC_Handler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) PendSV_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void PendSV_Handler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SysTick_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SysTick_Handler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) POWER_CLOCK_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void POWER_CLOCK_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) RADIO_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RADIO_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) UART0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void UART0_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SPI0_TWI0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI0_TWI0_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SPI1_TWI1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI1_TWI1_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) GPIOTE_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void GPIOTE_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) ADC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ADC_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) TIMER0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIMER0_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) TIMER1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIMER1_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) TIMER2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIMER2_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) RTC0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RTC0_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) TEMP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TEMP_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) RNG_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RNG_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) ECB_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ECB_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) CCM_AAR_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void CCM_AAR_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) WDT_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void WDT_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) RTC1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RTC1_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) QDEC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void QDEC_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) LPCOMP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LPCOMP_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SWI0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SWI0_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SWI1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SWI1_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SWI2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SWI2_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SWI3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SWI3_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SWI4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SWI4_IRQHandler();
	asm("bkpt 255");
};

void __attribute__ ((weak)) SWI5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SWI5_IRQHandler();
	asm("bkpt 255");
};

#else
void NMI_Handler()             __attribute__ ((weak, alias ("Default_Handler")));
void HardFault_Handler()       __attribute__ ((weak, alias ("Default_Handler")));
void SVC_Handler()             __attribute__ ((weak, alias ("Default_Handler")));
void PendSV_Handler()          __attribute__ ((weak, alias ("Default_Handler")));
void SysTick_Handler()         __attribute__ ((weak, alias ("Default_Handler")));
void POWER_CLOCK_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void RADIO_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void UART0_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void SPI0_TWI0_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void SPI1_TWI1_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void GPIOTE_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void ADC_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void TIMER0_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void TIMER1_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void TIMER2_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void RTC0_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void TEMP_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void RNG_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void ECB_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void CCM_AAR_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void WDT_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void RTC1_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void QDEC_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void LPCOMP_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void SWI0_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SWI1_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SWI2_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SWI3_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SWI4_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SWI5_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
#endif

void * g_pfnVectors[0x30] __attribute__ ((section (".isr_vector"))) = 
{
	&_estack,
	&Reset_Handler,
	&NMI_Handler,
	&HardFault_Handler,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&SVC_Handler,
	NULL,
	NULL,
	&PendSV_Handler,
	&SysTick_Handler,
	&POWER_CLOCK_IRQHandler,
	&RADIO_IRQHandler,
	&UART0_IRQHandler,
	&SPI0_TWI0_IRQHandler,
	&SPI1_TWI1_IRQHandler,
	NULL,
	&GPIOTE_IRQHandler,
	&ADC_IRQHandler,
	&TIMER0_IRQHandler,
	&TIMER1_IRQHandler,
	&TIMER2_IRQHandler,
	&RTC0_IRQHandler,
	&TEMP_IRQHandler,
	&RNG_IRQHandler,
	&ECB_IRQHandler,
	&CCM_AAR_IRQHandler,
	&WDT_IRQHandler,
	&RTC1_IRQHandler,
	&QDEC_IRQHandler,
	&LPCOMP_IRQHandler,
	&SWI0_IRQHandler,
	&SWI1_IRQHandler,
	&SWI2_IRQHandler,
	&SWI3_IRQHandler,
	&SWI4_IRQHandler,
	&SWI5_IRQHandler,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
};

void SystemInit();
void __libc_init_array();
int main();

extern void *_sidata, *_sdata, *_edata;
extern void *_sbss, *_ebss;

void __attribute__((naked, noreturn)) Reset_Handler()
{
	asm volatile(".equ NRF_POWER_RAMON_ADDRESS,0x40000524");
	asm volatile(".equ NRF_POWER_RAMON_RAMxON_ONMODE_Msk,3");
	asm volatile("LDR     R0, =NRF_POWER_RAMON_ADDRESS");
	asm volatile("LDR     R2, [R0]");
	asm volatile("MOVS    R1, #NRF_POWER_RAMON_RAMxON_ONMODE_Msk");
	asm volatile("ORR     R2, R2, R1");
	asm volatile("STR     R2, [R0]");
	//Normally the CPU should will setup the based on the value from the first entry in the vector table.
	//If you encounter problems with accessing stack variables during initialization, ensure 
	//asm ("ldr sp, =_estack");

	void **pSource, **pDest;
	for (pSource = &_sidata, pDest = &_sdata; pDest != &_edata; pSource++, pDest++)
		*pDest = *pSource;

	for (pDest = &_sbss; pDest != &_ebss; pDest++)
		*pDest = 0;

	SystemInit();
	__libc_init_array();
	(void)main();
	for (;;) ;
}

void __attribute__((naked, noreturn)) Default_Handler()
{
	//If you get stuck here, your code is missing a handler for some interrupt.
	//Define a 'DEBUG_DEFAULT_INTERRUPT_HANDLERS' macro via VisualGDB Project Properties and rebuild your project.
	//This will pinpoint a specific missing vector.
	for (;;) ;
}
